function c = xcorr(a, b, option)
    %	XCORR(A,B), where A and B are same-length ts_channel objects, returns the
    %	length 2*M-1 cross-correlation sequence in a column vector.
    %	XCORR(A), when A is a ts_channel object, is the auto-correlation sequence.
    %
    %   Calls xcorr_meat for processing.  xcorr_meat is an old version
    %   of xcorr from the Signal Processing Toolbox
    if nargin==1,
        c = xcorr_static(a.data);
    elseif nargin==2,
        if ischar(b)
            c=xcorr_static(a.data,b);
        elseif isa(b,'ts_data_channel')
            c=xcorr_static(a.data,b.data);
        else
            error('b is neither a string, nor a ts_data_channel object')
        end
    elseif nargin==3,
        if isa(b,'ts_data_channel') && ischar('opt'),
            c=xcorr_static(a.data,b.data,option);
        else
            if ~isa(b,'ts_data_channel')
                error('b is not a ts_data_channel object');
            else
                error('"option" is not a string');
            end
        end
    else
        error('illegal # of arguments: %d',nargin);
    end
end
