function save(obj)
% Save ts_file information to an executable file
% Usage: save(dfile)

[filename,pathname]=uiputfile('myparms.m','Save ts_file parameter file');
if exist('pathname','var');
	cd(pathname);
end
fid=fopen(filename,'w');
%[p,name,e,v]=fileparts(filename);

fprintf(fid,'df=ts_file(''%s'',''%s'');\n',obj.filename,obj.format);
fprintf(fid,'df.pathname=%s;\n',    obj.pathname);
fprintf(fid,'df.statname=%s;\n',    obj.instname);
fprintf(fid,'df.nChannels=%d;\n', obj.nChannels);
fprintf(fid,'df.readchans=[%s];\n',num2str(obj.readchans));
%fprintf(fid,'df.samprate=%g;\n', obj.samprate);
fprintf(fid,'df.clockdrift=%g;\n',obj.clockdrift);
fprintf(fid,'df.tzoffset=%g;\n', obj.tzoffset);
fprintf(fid,'df.synctime=''%s'';\n',char(obj.synctime));
fprintf(fid,'df.lat=%s;\n',      obj.lat);
fprintf(fid,'df.lon=%s;\n',      obj.lon);
fprintf(fid,'df.elev=%s;\n',     obj.elev);
fprintf(fid,'df.wdepth=%s;\n',   obj.wdepth);
fprintf(fid,'df.custom=%s;\n',   celltext(obj.custom));
for i=1:dfile.nChannels,
    chan=dfile.ch_metadata(i);
    resp=chan.response;
	filtstring=sprintf('ts_response(''PZ'',''%s'',''%s'',%g,[%s],[%s])',resp.DesiredUnits,resp.StoredUnits,resp.gain,num2str(resp.poles),num2str(resp.zeros));
	fprintf(fid,'df.ch_metadata(%d).station=''%s'';\n',i,chan.station);
	fprintf(fid,'df.ch_metadata(%d).response=%s;\n',i,filtstring);
end

function txt = celltext(tc)
txt='{';
for i = 1:length(tc),
	val = tc{i};
	if isa(val,'numeric'),
		if length(val)==1,
			txt = [txt ' ' num2str(val)];
        else
			txt = [txt ' [' num2str(val) ']'];
		end
	elseif ischar(val),
		txt = [txt '''' val ''''];
	else
		txt = [txt ' (' class(val) ' object)'];
	end
	if i < length(tc),
		txt = [txt ','];
	end
end
txt=[txt '}'];
	
