classdef ts_xferfun
% Transfer functions, created by ts_spectra.calcXF()
%
%% Description
% The transfer function is the LINEAR relation between two data channels.
% It is calculated from the spectral levels, the coherency, and an assumption
% of which channel contains most of the uncorrelated noise.
% It can be used to remove a signal or noise recorded on one channel from another channel
% The transfer function is defined as the Response channel divided by the driving channel
% in the complex frequency domain.
% The "gooddata" parameter is important for defining where the transfer function is valable
% (there exists a linear relation between the two channels)
% 
%% Properties:
%    freqs       - frequencies
%    channel     - Data and metadata       (ts_xferfun_channel)
%    figureprops - figure properties       (ts_figureproperties)
%    nChannels   - number of channels      (READ-ONLY, DEPENDENT)
%    gooddata    - returns AND(channel(:).gooddata)
%                  or sets all channel(:).gooddata) to same value
%
%% Methods:
%    ts_xferfun - Creator
%    plus       - Combine two ts_xferfun objects
%    plot       - Plot 
%
%% Examples
% None!
%
%% See Also
% <ts_xferfun_channel_help.html |ts_xferfun_channel|>, <ts_figureproperties_help.html |ts_figureproperties|>
% <ts_spectra_help.html |ts_spectra|>