classdef ts_channelinfo_basic
    % Handles basic channels for ts_file class
    % I created this because arrays of structures are hard to make secure
    
    properties
       component='';    % Channel component (up to 3 letters)
       response=ts_response;    % channel response
    end
    
    methods
        %% SET METHODS
        function obj=set.component(obj,val)
            if ~isa(val,'char'), error('value must be a character string'); end
            if length(val)>3, 
                oldval=val;
                if val(3)==' ';
                    val=val([1:2 4]);
                else
                    val=val(1:3);
                end
                ts_verbose(2,'cutting component name down to 3 characters: from "%s" to "%s"',oldval,val);
                val=val(1:3);
            end
            obj.component=val;
        end
        function obj=set.response(obj,val)
            if ~isa(val,'ts_response'), error('value must be a ts_response object'); end
            obj.response=val;
        end
        
        %% DISPLAY AND CHAR METHODS
        function txt=char(obj,padding)
            % padding pads the left side, to give an offset
            if ~exist('padding','var'), padding=0; end
            pformat=sprintf('%%%ds',padding);
            pad=sprintf(pformat,'');
            txt=[];
            tmp=[]; for i=1:length(obj), tmp=[tmp sprintf('%-13s ',['''' obj(i).component ''''])]; end
            txt=[txt sprintf('%s%10s:        %s\n',pad,'component',tmp)];
            txt=[txt sprintf('%s%10s: %s object\n',pad,'response',class(obj(1).response))];
            txt=[txt sprintf('%s',char([obj(:).response],padding+10))];
         end        
       function disp(obj)
           disp(char(obj));
       end     

    end %methods
end % classdef
        