function thefile=tsf_LCPO_4CHNORESPONSE(theInput)
% tsf_LCPO_4CHNORESPONSE creates a ts_file instance for a generic 4-channel
% L-CHEAPO (no instrument response)

    if isa(theInput,'ts_file'),
        if theInput.nChannels~=4,
            error('You tried to force a %d-channel ts_file object to be 4-channel!')
        end
        thefile=theInput;
    else
        thefile=ts_file(theInput,'LCPO');
        thefile.nChannels=4;    
    end
    
    % Enter channel names ('S' is for samprate=10-80, 'E' for samprate>80
    thefile.ch_metadata(1).component='??1';    % Hydrophone
    thefile.ch_metadata(2).component='??2';    % Hydrophone
    thefile.ch_metadata(3).component='??3';    % Hydrophone
    thefile.ch_metadata(4).component='??4';    % Hydrophone
    
    % Enter standard instrument response
    gain_AD=1165084;
    gain_ampli_hydro=16;
    thefile.ch_metadata(1).response=ts_response('PZ','Pa','counts',1,[],0,1);
    thefile.ch_metadata(2).response=ts_response('PZ','Pa','counts',1,[],0,1);
    thefile.ch_metadata(3).response=ts_response('PZ','Pa','counts',1,[],0,1);
    thefile.ch_metadata(4).response=ts_response('PZ','Pa','counts',1,[],0,1);
end

