function thefile=tsf_LCPO_HYDROOCT(theInput)
% tsf_LCPO_HYDROOCT creates a ts_file instance for L-Cheapo HydroOctopus
% (currently 2 channels for tests)

    if isa(theInput,'ts_file'),
        if theInput.nChannels~=2,
            error('You tried to force a %d-channel ts_file object to be an LCPO_HydroOctopus')
        end
        thefile=theInput;
    else
        thefile=ts_file(theInput,'LCPO');
        thefile.nChannels=2;    
    end
    
    % Enter channel names ('S' is for samprate=10-80, 'E' for samprate>80
    thefile.ch_metadata(1).component='SD1';    % Hydrophone
    thefile.ch_metadata(2).component='SD2';    % Hydrophone
    
    % Enter standard instrument response
    gain_AD=1165084;
    gain_ampli_hydro=16;
    thefile.ch_metadata(1).response=ts_response('PZ','Pa','counts',gain_AD*gain_ampli_hydro*6.00e-4*4.9,-6.6667,0,2*pi*100);
    thefile.ch_metadata(2).response=ts_response('PZ','Pa','counts',gain_AD*gain_ampli_hydro*6.00e-4*4.9,-6.6667,0,2*pi*100);
end

