function tsp_DatafileGUIMod(command) %, value,options)
		
global TEMP_QUITSTATE
global TSPLOT_DATAFILE
global TSPLOT_VARIABLES

thegui = gcf;
command = lower(command); % Allows for caps vs no caps
if strcmp(command,'fillgui'),
	fillGUI(thegui);
	return
end
str = get(gcbo,'String');
val = get(gcbo,'Value');
currchan = get(findobj(thegui,'Tag','df_channelpopup'),'Value');
switch command,
	case 'modnumchans',	
		modifyNumChans(thegui);
	case 'getfilename',	
		[filename,pathname] = uigetfile('','Select the data file to read');
		TSPLOT_DATAFILE.filename= fullfile(pathname,filename);
		set(gcbo,'String',filename);		
	case 'makePrevVisible',
		set(findobj(thegui,'Tag','df_prevButton'),'Visible','on');
	case 'modftypefrommenu',
		TSPLOT_DATAFILE.format=str{val};
		dft = TSPLOT_VARIABLES.datafileformats;
		set(findobj(thegui,'Tag','df_fileformatstring'),'String',dft{val});
	case 'modftypefromstr',
		TSPLOT_DATAFILE.format=str;
		dft = TSPLOT_VARIABLES.datafileformats;
		iother = length(dft);	% Value of "non-registered" file format
		i = strmatch(upper(str),dft);
		if isempty(i), i = iother; else i = i(1); end
		set(findobj(thegui,'Tag','df_fileformat'),'Value',i);
		if i~=iother, set(findobj(thegui,'Tag','df_fileformatstring'),'String',dft{i}); end
	case 'getparmfile',	
		[filename,pathname] = uigetfile('*.m','Select a parameter file');
		addpath(pathname);
		fname = filename(1:length(filename)-2);
		eval(['TSPLOT_DATAFILE = ' fname ';']); readchans=[];
		if isempty(readchans),
			readchans = 1:TSPLOT_DATAFILE.nChannels;
		end
		global TEMP_READCHANS
		TEMP_READCHANS=readchans;
		fillGUI(thegui);
		findobj(thegui,'Tag','df_parmfilename');
		set(findobj(thegui,'Tag','df_parmfilename'),'String',filename);
	case 'modinstname',
		TSPLOT_DATAFILE.instname=str;
	case 'modinstnum',
		TSPLOT_DATAFILE.instnum=str2double(str);
	case 'modinstclockdrift',
		TSPLOT_DATAFILE.clockdrift=str2double(str);
	case 'modstarttime',
		TSPLOT_DATAFILE.starttime=str;
	case 'modinstlat',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'instlat',str2double(str));
	case 'modinstlon',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'instlon',str2double(str));
	case 'modinstelev',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'instelev',str2double(str));
	case 'modinstwdepth',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'instwdepth',str2double(str));
	case 'modeventtime',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'eventtime',str);
	case 'modeventlat',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'eventlat',str2double(str));
	case 'modeventlon',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'eventlon',str2double(str));
	case 'modeventdepth',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'eventdepth',str2double(str));
	case 'modeventwdepth',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'eventwdepth',str2double(str));
	case 'modrawreclen',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawRecLen',str2double(str));
	case 'modrawdatalen',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawDataLen',str2double(str));
	case 'modrawheaderaddrs',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawHeadAddrs',str2num(str));
	case 'modrawheadersize',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawHeadBytes',str2double(str));
	case 'modrawtimewordpos',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawTWPos',str2double(str));
	case 'modrawbyteswap',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawHeadBytes',val);
	case 'modrawbitspersample',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawbitspersample',str2double(str));
	case 'modrawcustom1',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawcustom1',str2num(str));
	case 'modrawcustom2',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawcustom2',str2num(str));
	case 'modrawcustom3',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawcustom3',str2num(str));
	case 'modrawcustom4',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'rawcustom4',str2num(str));
	case 'choosedisplaychan',
		fillGUIchan(thegui,currchan);
	case 'modchname',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'chname',currchan,str);
	case 'modchunits',
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'chunits',currchan,str);
	case 'modchgain',
		[g,p,z] = get(TSPLOT_DATAFILE,'chfilt',currchan);
		g = num2str(str);
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'chfilt',currchan,g,p,z);
	case 'modchpoles',
		[g,p,z] = get(TSPLOT_DATAFILE,'chfilt',currchan);
		p = num2str(str);
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'chfilt',currchan,g,p,z);
	case 'modchzeros',
		[g,p] = get(TSPLOT_DATAFILE,'chfilt',currchan);
		z = num2str(str);
		TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'chfilt',currchan,g,p,z);
	case 'savevalues',		% Save the values specified by the GUI
		[filename,pathname] = uiputfile('parmfile.m','Save As');
		fid = fopen([pathname filename],'w');
		createParmFile(fid,TSPLOT_DATAFILE);
		fclose(fid);
	case {'acceptvalues','prev_dfile','next_dfile'}, % Accept the values specified by the GUI
		close(thegui);
		TEMP_QUITSTATE = command;
	case 'cancel',
		TEMP_QUITSTATE = command;
		close(thegui);
	otherwise,
		error(['unknown command <' command '>']);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fillGUI(thegui)
% First take care of the modifyable parts of the GUI
global TSPLOT_DATAFILE
global TSPLOT_VARIABLES
numchans = TSPLOT_DATAFILE.nChannels;
set(findobj(thegui,'Tag','df_nChannels'),'String',num2str(numchans));
modifyNumChans(thegui);
dft = TSPLOT_VARIABLES.datafileformats; str = TSPLOT_DATAFILE.format;
set(findobj(thegui,'Tag','df_fileformat'),'String',dft);
i = strmatch(str,dft);
iother = length(dft);
if isempty(i), i = iother; theStr = str; else i = i(1); theStr = dft{i}; end
set(findobj(thegui,'Tag','df_fileformat'),'Value',i);
set(findobj(thegui,'Tag','df_fileformatstring'),'String',theStr);
% Plug the values in
str = get(TSPLOT_DATAFILE,'filename'); if isempty(str), str = 'None'; end
set(findobj(thegui,'Tag','df_filename'),'String',str);
set(findobj(thegui,'Tag','df_instname'),'String',get(TSPLOT_DATAFILE,'instname'));
set(findobj(thegui,'Tag','df_instnum'),'String',num2str(get(TSPLOT_DATAFILE,'instnum')));
set(findobj(thegui,'Tag','df_sampfreq'),'String',num2str(get(TSPLOT_DATAFILE,'sampfreq')));
set(findobj(thegui,'Tag','df_clockdrift'),'String',num2str(get(TSPLOT_DATAFILE,'clockdrift')));
set(findobj(thegui,'Tag','df_starttime'),'String',char(get(TSPLOT_DATAFILE,'starttime')));
loc=get(TSPLOT_DATAFILE,'location');
[la,lo,el,wde] = deal(loc{:});
set(findobj(thegui,'Tag','df_instlat'),'String',num2str(la));
set(findobj(thegui,'Tag','df_instlon'),'String',num2str(lo));
set(findobj(thegui,'Tag','df_instelev'),'String',num2str(el));
set(findobj(thegui,'Tag','df_instwdepth'),'String',num2str(wde));
custom=get(TSPLOT_DATAFILE,'custom');
if length(custom)==7,
	set(findobj(thegui,'Tag','df_rawreclen'),'String',num2str(custom{1}));
	set(findobj(thegui,'Tag','df_rawdatalen'),'String',num2str(custom{2}));
	set(findobj(thegui,'Tag','df_rawbyteswap'),'Value',custom{3}==1);
	set(findobj(thegui,'Tag','df_rawheaderaddrs'),'String',num2str(custom{4}));
	set(findobj(thegui,'Tag','df_rawheadersize'),'String',num2str(custom{5}));
	set(findobj(thegui,'Tag','df_rawtimewordpos'),'String',num2str(custom{6}));
	set(findobj(thegui,'Tag','df_rawbitspersample'),'String',num2str(custom{7}));
end
set(findobj(thegui,'Tag','df_chnum'),'String','1');
fillGUIchan(thegui,1);
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fillGUIchan(thegui,chnum)
global TSPLOT_DATAFILE
set(findobj(thegui,'Tag','df_chname'),'String',get(TSPLOT_DATAFILE,'chname',chnum));
set(findobj(thegui,'Tag','df_chunits'),'String',get(TSPLOT_DATAFILE,'chunits',chnum));
filtparm = get(TSPLOT_DATAFILE,'chfilt',chnum);
set(findobj(thegui,'Tag','df_chgain'),'String',num2str(filtparm.gain));
set(findobj(thegui,'Tag','df_chpoles'),'String',num2str(filtparm.poles));
set(findobj(thegui,'Tag','df_chzeros'),'String',num2str(filtparm.zeros));

	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function modifyNumChans(thegui); %,dreadchans),
global TSPLOT_DATAFILE
newnumchans = str2double(get(findobj(thegui,'Tag','df_nChannels'),'String'));
if newnumchans == 0 || isempty(newnumchans),
	newnumchans = 1;
end
TSPLOT_DATAFILE = set(TSPLOT_DATAFILE,'numchans',newnumchans);
for i = 1:newnumchans,
	str{i} = num2str(i);
end;
set(findobj('Tag','df_channelpopup'),'String',str);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function createParmFile(fid,dfile)
% to keep this up-to-date, compare the parameters stored here with those listed
% when you type "ts_file" 
fprintf(fid,'%%This is an TiSKit parameter file\n');
fprintf(fid,'%%All TiSKit parameter files MUST create an ts_file object named ''datafile''\n\n');
fprintf(fid,'df = ts_file;\n');
fprintf(fid,'df.filename=%s;\n',dfile.filename);
fprintf(fid,'df.format=%s\n',dfile.format);
fprintf(fid,'df = set(df,''instname'',''%s'');\n',get(dfile,'instname'));
fprintf(fid,'df = set(df,''instnum'',%d);\n',get(dfile,'instnum'));
%fprintf(fid,'df = set(df,''datatype'',''%s'');',get(dfile,'datatype'));
fprintf(fid,'df = set(df,''sampfreq'',%g);\n',get(dfile,'sampfreq'));
fprintf(fid,'df = set(df,''clockdrift'',%g);\n',get(dfile,'clockdrift'));
fprintf(fid,'df = set(df,''starttime'',''%s'');\n',char(get(dfile,'starttime')));
[lat,lon,elev,wdepth] = get(dfile,'location');
fprintf(fid,'df = set(df,''location'',%g,%g,%g,%g);\n',lat,lon,elev,wdepth);
fprintf(fid,'df = set(df,''eventtime'',''%s'');\n',char(get(dfile,'eventtime')));
[lat,lon,depth,wdepth] = get(dfile,'eventloc');
fprintf(fid,'df = set(df,''eventloc'',%g,%g,%g,%g);\n',lat,lon,elev,wdepth);
fprintf(fid,'df = set(df,''RawRecLen'',%g);\n',get(dfile,'rawRecLen'))
fprintf(fid,'df = set(df,''RawDataLen'',%g);\n',get(dfile,'rawDataLen'))
fprintf(fid,'df = set(df,''RawByteSwap'',%g);\n',get(dfile,'RawByteSwap'))
fprintf(fid,'df = set(df,''RawHeadAddr'',%g);\n',get(dfile,'rawHeadAddr'))
fprintf(fid,'df = set(df,''RawHeadSize'',%g);\n',get(dfile,'RawHeadSize'))
fprintf(fid,'df = set(df,''RawTimeWordPosition'',%g);\n',get(dfile,'RawTimeWordPosition'))
fprintf(fid,'df = set(df,''RawBitsPerSample'',%g);\n',get(dfile,'RawBitsPerSample'))
fprintf(fid,'df = set(df,''rawCustom1'',%g);\n',get(dfile,'rawCustom1'))
fprintf(fid,'df = set(df,''rawCustom2'',%g);\n',get(dfile,'rawCustom2'))
fprintf(fid,'df = set(df,''rawCustom3'',%g);\n',get(dfile,'rawCustom3'))
fprintf(fid,'df = set(df,''rawCustom4'',%g);\n',get(dfile,'rawCustom4'))
numchans = dfile.nChannels;
fprintf(fid,'df = set(df,''nChannels'',%d);\n',numchans);
for i = 1:numchans,
	fprintf(fid,'df = set(df,''chname'',%d,''%s'');\n',i,get(dfile,'chname',i));
	fprintf(fid,'df = set(df,''chunits'',%d,''%s'');\n',i,get(dfile,'chunits',i));
	[g,p,z] = get(dfile,'chfilt',i);
	fprintf(fid,'df = set(df,''chfilt'',%d,%g,[%s],[%s]);\n',i,g,num2str(p),num2str(z));
end
fprintf(fid,'datafile = df;\n');
return

%-------------------------------------------------------------------------------------
