function tsp_FreqGUIMod(command, value,options)
%

global TSPLOT_VARIABLES
global TSPLOT_SPECTRA
global TSPLOT_XFERFUN
command = lower(command); % Allows for caps vs no caps
switch command,
    case 'showpanes', % Show data panes
        disp('in showpanes');
        TSPLOT_SPECTRA.figureprops.overlay = 0;
        set(gcbo,'Checked','on');
        set(gcbo,'Enable','off');
        otherobj=findobj(gcbf,'Tag','MenuShowOverlay');
        set(otherobj,'Checked','off');
        set(otherobj,'Enable','on');
        tsp_plotspect;
    case 'showoverlay',
        disp('in showoverlay');
        TSPLOT_SPECTRA.figureprops.overlay = -1;
        set(gcbo,'Checked','on');
        set(gcbo,'Enable','off');
        otherobj=findobj(gcbf,'Tag','MenuShowPanes');
        set(otherobj,'Checked','off');
        set(otherobj,'Enable','on');
        tsp_plotspect;
	case 'setplotbox',
		if isempty(value), return, end;
		local_setxmin(value(1));
		local_setxmax(value(2));
		local_setymin(value(3));
		local_setymax(value(4));
		set(findobj(gcbf,'Tag','CBAutoFRange'),'Value',0);
		set(findobj(gcbf,'Tag','CBAutoYRange'),'Value',0);
		tsp_plotspect;
	case 'setymin',
		set(findobj(gcbf,'Tag','CBAutoYRange'),'Value',0);
		local_setymin(str2double(get(gcbo,'String')));
		local_setymax(str2double(get(findobj(gcbf,'Tag','EditYMax'),'String')));
		tsp_plotspect;		
	case 'setymax',
		set(findobj(gcbf,'Tag','CBAutoYRange'),'Value',0);
		local_setymin(str2double(get(findobj(gcbf,'Tag','EditYMin'),'String')));
		local_setymax(str2double(get(gcbo,'String')));
		tsp_plotspect;		
	case 'setfmin',
		set(findobj(gcbf,'Tag','CBAutoFRange'),'Value',0);
		local_setxmin(str2double(get(gcbo,'String')));
		local_setxmax(str2double(get(findobj(gcbf,'Tag','EditFMax'),'String')));
		tsp_plotspect;		
	case 'setfmax',
		set(findobj(gcbf,'Tag','CBAutoFRange'),'Value',0);
		local_setxmin(str2double(get(findobj(gcbf,'Tag','EditFMin'),'String')));
		local_setxmax(str2double(get(gcbo,'String')));
		tsp_plotspect;		
	case 'toggleautoyrange',
		h1 = findobj(gcf,'Tag','EditYMin');
		h2 = findobj(gcf,'Tag','EditYMax');
		if value == 0, %  turn off auto ranging
			local_setymin(str2double(get(h1,'String')));
			local_setymax(str2double(get(h2,'String')));
        else
			local_setymin(NaN);
			local_setymax(NaN);
		end
		if exist('options','var');
			if strcmp(options,'noplot'), return, end, end
		tsp_plotspect;
	case 'toggleautofrange',
		h1 = findobj(gcf,'Tag','EditFMin');
		h2 = findobj(gcf,'Tag','EditFMax');
		if value == 0, %  turn off auto ranging
			local_setxmin(str2double(get(h1,'String')));
			local_setxmax(str2double(get(h2,'String')));
        else
			local_setxmin(NaN);
			local_setxmax(NaN);
		end
		if exist('options','var');
			if strcmp(options,'noplot'), return, end, end
		tsp_plotspect;
	case 'plotspect',
		if value == 0,
			set(gcbo,'Value',1);	% Can't turn off radio buttons
		end
		set(findobj(gcbf,'Tag','RBcoher'),'Value',0);
		set(findobj(gcbf,'Tag','RBxf'),'Value',0);
		TSPLOT_VARIABLES.spectinfo.whichspectplot = 'spect';
		tsp_plotspect;
	case 'plotcoher',
		if value == 0,
			set(gcbo,'Value',1);	% Can't turn off radio buttons
		end
		set(findobj(gcbf,'Tag','RBspect'),'Value',0);
		set(findobj(gcbf,'Tag','RBxf'),'Value',0);
		TSPLOT_VARIABLES.spectinfo.whichspectplot = 'coher';
		tsp_plotspect;
	case 'calcxfunc',
		if value == 0,
			set(gcbo,'Value',1);	% Can't turn off radio buttons
		end
		set(findobj(gcbf,'Tag','RBspect'),'Value',0);
		set(findobj(gcbf,'Tag','RBcoher'),'Value',0);
		for i = 1:TSPLOT_SPECTRA.nChannels,
			names{i} = sprintf('CH%d: %s',i,TSPLOT_SPECTRA.sinfo(i).name);
		end
		[drivechan, ok] = listdlg(	'ListString',names, ...
									'SelectionMode','single', ...
									'PromptString','Driving Channel');
		ctr = 0; clear names
		for i = 1:TSPLOT_SPECTRA.nChannels,
			if i ~= drivechan,
				ctr = ctr+1;
				names{ctr} = sprintf('CH%d: %s',i,TSPLOT_SPECTRA.sinfo(i).name);
				chnum(ctr) = i;
			end
		end
		[j, ok] = listdlg(	'ListString',names, ...
							'SelectionMode','single', ...
							'PromptString','Response Channel');
		respchan = chnum(j);
		% For now, only do the "no noise on driving channel" case
		TSPLOT_XFERFUN = TSPLOT_SPECTRA.calcXF(drivechan,respchan);
		TSPLOT_XFERFUN.figureprops.bottomoffset=60;
		TSPLOT_XFERFUN.figureprops.subplot(1).xmin = TSPLOT_SPECTRA.figureprops.subplot(1).xmin;
		TSPLOT_XFERFUN.figureprops.subplot(1).xmax = TSPLOT_SPECTRA.figureprops.subplot(1).xmax;
% 		TSPLOT_XFERFUN = set(TSPLOT_XFERFUN,'chxmin',1,TSPLOT_SPECTRA.figureprops.subplot(1).xmin);
% 		TSPLOT_XFERFUN = set(TSPLOT_XFERFUN,'chxmax',1,TSPLOT_SPECTRA.figureprops.subplot(1).xmax);
		TSPLOT_VARIABLES.spectinfo.whichspectplot = 'xferfun';
		tsp_plotspect;
	case 'readrecord',
		global TSPLOT_DATA
		switch value
			case 'next',
				recnum = TSPLOT_VARIABLES.recordnumber + 1;
			case {'prev','previous'},
				recnum = TSPLOT_VARIABLES.recordnumber - 1;
			otherwise,
				recnum = str2double(value);
		end
		ctr = 0;
		for i = 1:TSPLOT_VARIABLES.numdevs,
			tdatanew = ap_read(recnum,TSPLOT_VARIABLES.files(i),TSPLOT_VARIABLES.files(i).readchans);
			if ~isa(TSPLOT_DATA,'ts_data'),	%First time through	
				TSPLOT_DATA = tdatanew;
			else
				for j = 1:tdatanew.nChannels;
					TSPLOT_DATA.data(ctr+j,:) = tdatanew.data(j,:);
				end
				ctr = ctr + tdatanew.nChannels;
			end
		end
		h = findobj(gcf,'Tag','EditRecord');
		set(h,'String',num2str(recnum));
		TSPLOT_VARIABLES.recordnumber= recnum;
		if exist('options');
			if options=='noplot', return, end, end
		tsp_plotspect;
	case 'lineclick',
		frequency = value(1,1); y = value(1,2);
		if strcmp(TSPLOT_VARIABLES.spectinfo.whichspectplot,'spectra'),
			APchan = sscanf(get(gca,'Tag'),'APchan%d')
			units = TSPLOT_SPECTRA.sinfo(APchan).units;
			otext = sprintf('%.3gHz (%.3gs), %.3g %s',frequency,1/frequency,y,units);
		else,
			otext = sprintf('%.3gHz (%.3gs), %.3g',frequency,1/frequency,y);
		end
		h = findobj(gcf,'Tag','EditGUIComments');
		set(h,'String',otext);
	otherwise,
		error(['unknown command <' command '>']);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function local_setxmin(value)
global TSPLOT_VARIABLES
if strcmp(TSPLOT_VARIABLES.spectinfo.whichspectplot,'xferfun')
	global TSPLOT_XFERFUN
	TSPLOT_XFERFUN.figureprops.xmin = value(1);
else
	global TSPLOT_SPECTRA
    for i=1:length(TSPLOT_SPECTRA.figureprops.subplot),
        TSPLOT_SPECTRA.figureprops.subplot(i).xmin = value(1);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function local_setxmax(value)
global TSPLOT_VARIABLES
if strcmp(TSPLOT_VARIABLES.spectinfo.whichspectplot,'xferfun')
	global TSPLOT_XFERFUN
	TSPLOT_XFERFUN.figureprops.xmax=value(1);
else
	global TSPLOT_SPECTRA
    for i=1:length(TSPLOT_SPECTRA.figureprops.subplot),
        TSPLOT_SPECTRA.figureprops.subplot(i).xmax=value(1);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function local_setymin(value)
global TSPLOT_VARIABLES
if strcmp(TSPLOT_VARIABLES.spectinfo.whichspectplot,'xferfun')
	global TSPLOT_XFERFUN
%	TSPLOT_XFERFUN = set(TSPLOT_XFERFUN,'plotymin',value(1));
	TSPLOT_XFERFUN.figureprops.subplot(1).ymin=value(1);
else
	global TSPLOT_SPECTRA
    for i=1:length(TSPLOT_SPECTRA.figureprops.subplot),
        TSPLOT_SPECTRA.figureprops.subplot(i).ymin=value(1);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function local_setymax(value)
global TSPLOT_VARIABLES
if strcmp(TSPLOT_VARIABLES.spectinfo.whichspectplot,'xferfun')
	global TSPLOT_XFERFUN
	%TSPLOT_XFERFUN = set(TSPLOT_XFERFUN,'plotymax',value(1));
	TSPLOT_XFERFUN.figureprops.subplot(1).ymax=value(1);
else
	global TSPLOT_SPECTRA
    for i=1:length(TSPLOT_SPECTRA.figureprops.subplot),
        TSPLOT_SPECTRA.figureprops.subplot(i).ymax=value(1);
    end
end
