function tsp_plotspect()

global TSPLOT_SPECTRA
global TSPLOT_XFERFUN
global TSPLOT_VARIABLES

clf
switch TSPLOT_VARIABLES.spectinfo.whichspectplot,
	case 'coher',
		[axhands linehands] = plotcoher(TSPLOT_SPECTRA);
	case 'xferfun',
		[axhands linehands] = plot(TSPLOT_XFERFUN);
	otherwise,
        TSPLOT_SPECTRA
		[axhands linehands] = plot(TSPLOT_SPECTRA);
end
set(findobj(gcf,'Tag','TextSpectInfo'),'String',TSPLOT_VARIABLES.spectinfo.infoline);
for i = 1:length(axhands)
	% If someone clicks within an axis, let them select a box to view
	set(axhands(i),'ButtonDownFcn','tsp_FreqGUIMod(''setplotbox'',tsp_calcaxpos(gca,rbbox))');
	set(axhands(i),'Tag',['APchan' num2str(i)]);
end
for i = 1:length(linehands)
	% If someone clicks on a line, print out the time and value, or let them select a context menu
	h = linehands(i);
	APchan = sscanf(get(get(h,'Parent'),'Tag'),'APchan%d');
	set(linehands(i),'ButtonDownFcn','tsp_FreqGUIMod(''lineclick'',get(gca,''CurrentPoint''))');
%	set(linehands(i),'UIContextMenu',apl_contextmenu(APchan));
end
flim = get(axhands(1),'XLim');
ylim = get(axhands(1),'YLim');
for i = 2:length(axhands);
	flimtemp = get(axhands(i),'XLim');
	ylimtemp = get(axhands(i),'YLim');
	flim(1) = min(flim(1),flimtemp(1));
	flim(2) = max(flim(2),flimtemp(2));
	ylim(1) = min(ylim(1),ylimtemp(1));
	ylim(2) = max(ylim(2),ylimtemp(2));
end
set(findobj(gcf,'Tag','EditFMin'),'String',sprintf('%.1e',flim(1)));
set(findobj(gcf,'Tag','EditFMax'),'String',sprintf('%.1e',flim(2)));
set(findobj(gcf,'Tag','EditYMin'),'String',sprintf('%.1e',ylim(1)));
set(findobj(gcf,'Tag','EditYMax'),'String',sprintf('%.1e',ylim(2)));

function cm = apl_contextmenu(APchan);
global TSPLOT_SPECTRA
% Define context menu
cm = uicontextmenu;
% Define context menu items
item1 = uimenu(cm,'Label', 'P pick',	'Callback', '');
item1 = uimenu(cm,'Label', 'S Pick',	'Callback', '');
item1 = uimenu(cm,'Label', 'W pick',	'Callback', '');
item1 = uimenu(cm,'Label', 'Change value', 'Callback', '', ...
					'Separator','on');
if get(TSPLOT_DATA,'chdemultiplex',APchan) == 0,	% Channel not demultiplexed
	item1 = uimenu(cm,'Label', 'Demultiplex', 'Callback', 'tsp_DataCMenu(''demultiplex'','''')', ...
					'Separator','on');
				else,	% Channel demultiplexed
	item1 = uimenu(cm,'Label', 'Remultiplex', 'Callback', 'tsp_DataCMenu(''remultiplex'','''')', ...
					'Separator','on');
end
item1 = uimenu(cm,'Label', 'solid',		'Callback', 'tsp_DataCMenu(''datadisp'',''solid'')', ...
					'Tag','dispsolid', 'Separator','on','Checked','on');
item2 = uimenu(cm,'Label', 'dots',		'Callback', 'tsp_DataCMenu(''datadisp'',''dots'')', ...
					'Tag','dispdashed');
