function tsp_plottime()
global TSPLOT_DATA
global APVIEW_FILTDATA
global TSPLOT_VARIABLES

ts_debug(1,'Starting');

if ~isa(TSPLOT_DATA,'ts_data')
	ts_debug(1,'Bailing out because no data yet');
	return;
end	

fileinfoheight=0;

datainfoheight = 65;

% Offset the bottom of the plot by enough to avoid the buttons and info
TSPLOT_VARIABLES.timefigureprops.bottomoffset = datainfoheight+fileinfoheight;
TSPLOT_DATA.figureprops.bottomoffset = datainfoheight+fileinfoheight;

% Set up highlights for phase arrival picks
%pq = TSPLOT_VARIABLES.eqpick.qualitydefs / sampfreq;
numphases = length(TSPLOT_VARIABLES.eqpick.phasename);
%ihl = 0; highlights = []; colorwheel = 'rygcm';
picks=zeros(numphases,1);

% Plot the data
start=TSPLOT_VARIABLES.timeplot.start;
plotlength=TSPLOT_VARIABLES.timeplot.length;
if strcmp(TSPLOT_VARIABLES.tinfo.whichtoplot,'filtered')
%	[axhands linehands] = plot(APVIEW_FILTDATA,start,plotlength,'highlight',TSPLOT_VARIABLES.highlights,'figureprops',TSPLOT_VARIABLES.timefigureprops);
	[axhands linehands] = plot(APVIEW_FILTDATA,start,plotlength,'highlight',TSPLOT_VARIABLES.highlights,'figureprops',TSPLOT_DATA.figureprops);
else
%     TSPLOT_DATA
%     TSPLOT_VARIABLES.highlights
%     TSPLOT_VARIABLES.timefigureprops
%	[axhands linehands] = plot(TSPLOT_DATA,start,plotlength,'highlight',TSPLOT_VARIABLES.highlights,'figureprops',TSPLOT_VARIABLES.timefigureprops);
	[axhands linehands] = plot(TSPLOT_DATA,start,plotlength,'highlight',TSPLOT_VARIABLES.highlights,'figureprops',TSPLOT_DATA.figureprops);
end
ts_debug(1,'done plotting');
% Plot title, if it exists
%disp(['plotting title: ' TSPLOT_VARIABLES.title]);
subTitle(TSPLOT_VARIABLES.title);
% Allow view box selection by clicking within an axis
for i = 1:length(axhands)
%	set(axhands(i),'ButtonDownFcn','tsp_TimeGUIMod(''setplotbox'',tsp_calcaxpos(gca,rbbox))');
    set(axhands(i),'ButtonDownFcn','tsp_TimeGUIMod(''setplotbox'',tsp_calcaxpos(gca))');
	set(axhands(i),'Tag',['APchan' num2str(i)]);
end
% Activate time and value print when data is clicked, contextual menu when CTRL-clicked
for i = 1:length(linehands)
	h = linehands(i);
	APchan = sscanf(get(get(h,'Parent'),'Tag'),'APchan%d');
	set(linehands(i),'ButtonDownFcn','tsp_TimeGUIMod(''lineclick'',get(gca,''CurrentPoint''))');
	if exist('uicontextmenu','builtin'),	% if this version of Matlab has contextual menus
		set(linehands(i),'UIContextMenu',apl_contextmenu(APchan));
	end
end
%  Plot info at bottom of Window.  Why doesn't this work the first time through???
for i = 1:3,
	set(findobj(gcf,'Tag',['apt_phase' num2str(i) 'label']),...
							'String',TSPLOT_VARIABLES.eqpick.phasename{i});
	set(findobj(gcf,'Tag',['apt_phase' num2str(i) 'picks']),...
							'String',num2str(picks(i)));
end
if sum(picks)>0, set(findobj(gcf,'Tag','apt_outputpicks'),'Visible','on');
else			 set(findobj(gcf,'Tag','apt_outputpicks'),'Visible','off'); end
if ~isempty(TSPLOT_VARIABLES.eqpick.filename),
	[path,name,ext,ver] = fileparts(TSPLOT_VARIABLES.eqpick.filename);
	set(findobj(gcf,'Tag','apt_pickfile'),'String',sprintf('%s%s%s (%d)',...
						name,ext,ver,TSPLOT_VARIABLES.eqpick.numsaved));
end
if isa(TSPLOT_VARIABLES.dataStart,'ts_datetime'),
	dsStr = char(TSPLOT_VARIABLES.dataStart);
else dsStr = num2str(TSPLOT_VARIABLES.dataStart);
end
set(findobj(gcf,'Tag','EditRecord'),'String',dsStr);
dl =  TSPLOT_VARIABLES.dataLen; 
if dl==0,
	dlStr = 'Rest of the file';
else
	dlStr = sprintf('%.0f s (%.0f minutes)',dl,dl/60);
end
set(findobj(gcf,'Tag','DataLength'),'String',dlStr);
%plotStart = get(TSPLOT_VARIABLES.timefigureprops,'timePlotStart');
plotStart = TSPLOT_VARIABLES.timeplot.start;
if isa(plotStart,'ts_datetime'),
	set(findobj(gcf,'Tag','EditAddress'),'String',char(plotStart));
else
	set(findobj(gcf,'Tag','EditAddress'),'String',num2str(plotStart));
end
seglen =  TSPLOT_VARIABLES.timeplot.length;
if ischar(seglen),
    if strcmp(seglen,'0'), seglenstr='Auto';
    else seglenstr=seglen;
    end
else
    if seglen==0 || isnan(seglen), seglenstr = 'Auto';
    else seglenstr = num2str(seglen);
    end
end
set(findobj(gcf,'Tag','EditSegLength'),'String',seglenstr);
ts_debug(1,'Exiting');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cm = apl_contextmenu(APchan)
    global TSPLOT_VARIABLES
    global TSPLOT_DATA
    % Define context menu
    cm = uicontextmenu;
    % Define context menu items
%    pnames = TSPLOT_VARIABLES.eqpick.phasename;
%     if APchan>TSPLOT_VARIABLES.timefigureprops.nSubplots,
%         sp=TSPLOT_VARIABLES.timefigureprops.subplot(1);
%     else
%         sp=TSPLOT_VARIABLES.timefigureprops.subplot(APchan);
%     end
    if APchan>TSPLOT_DATA.nChannels,
        sp=TSPLOT_DATA.channel(1).subplotprops;
    else
        sp=TSPLOT_DATA.channel(APchan).subplotprops;
    end
%    for i = 1:length(pnames),
%        uimenu(cm,'Label', [pnames{i} ' pick'], ...
%            'Callback', ['tsp_DataCMenu(''pickArrival'',' num2str(i) ')']);
%    end
    if sp.demultiplex<=1,	% Channel not demultiplexed
        uimenu(cm,'Label', 'Demultiplex', 'Callback', 'tsp_DataCMenu(''demultiplex'','''')');
    else	% Channel demultiplexed
        uimenu(cm,'Label', 'Remultiplex', 'Callback', 'tsp_DataCMenu(''remultiplex'','''')', ...
            'Separator','on');
    end
    if strcmp(sp.linetype,'none'),
        checksolid = 'off'; else checksolid = 'on'; end
    if strcmp(sp.marker,'none'),
        checkdots = 'off'; else checkdots = 'on'; end

    uimenu(cm,'Label', 'solid',		'Callback', 'tsp_DataCMenu(''datadisp'',''solid'')', ...
        'Tag','dispsolid', 'Separator','on','Checked',checksolid);
    uimenu(cm,'Label', 'dots',		'Callback', 'tsp_DataCMenu(''datadisp'',''dots'')', ...
        'Tag','dispdashed','Checked',checkdots);
return

%--------------------------------------------------------
%function addpickplot(eventarrival,APchan,name);
%global TSPLOT_VARIABLES TSPLOT_DATA
%offsetaddr = eventarrival.address - get(TSPLOT_VARIABLES.timefigureprops,'chplotstartaddress',APchan);
%offsetsecs = offsetaddr/get(TSPLOT_DATA,'sampfreq');
%h = findobj(gcf,'Tag',sprintf('APchan%d',APchan))
%axes(h);
%ylim = get(h,'YLim');
%hold on
%plot(offsetsecs*ones(size(ylim)),ylim,'r-', 'HitTest','off');
%str = [name eventarrival.type eventarrival.direction num2str(eventarrival.quality)]
%ht = text(offsetsecs,max(ylim),str,'HorizontalAlignment','right','VerticalAlignment','Top','Color','r', 'HitTest','off');

%--------------------------------------------------------
function subTitle( txt )
% Centers a title over a group of subplots.

%ax = axes( 'Units', 'Normal', 'Position', [0.1 0.9 0.8 0.1], ...
%           'Visible', 'off' ) ; 
h=text(0.5,1,txt);
set(h,'Units','Normalized','Visible','on','HorizontalAlignment','Center','VerticalAlignment','Top')
% set( get( ax, 'Title' ), 'Visible', 'on' ) ;
% title( txt ) ;
% if ( nargout < 2 )
%   return ;
% end ;
% h = get( ax, 'Title' ) ;
